<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for carrierCompanyType StructType
 * @subpackage Structs
 */
class CarrierCompanyType extends AbstractStructBase
{
    /**
     * The company_id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $company_id;
    /**
     * The company_key
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $company_key;
    /**
     * The company_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $company_name;
    /**
     * Constructor method for carrierCompanyType
     * @uses CarrierCompanyType::setCompany_id()
     * @uses CarrierCompanyType::setCompany_key()
     * @uses CarrierCompanyType::setCompany_name()
     * @param int $company_id
     * @param string $company_key
     * @param string $company_name
     */
    public function __construct($company_id = null, $company_key = null, $company_name = null)
    {
        $this
            ->setCompany_id($company_id)
            ->setCompany_key($company_key)
            ->setCompany_name($company_name);
    }
    /**
     * Get company_id value
     * @return int
     */
    public function getCompany_id()
    {
        return $this->company_id;
    }
    /**
     * Set company_id value
     * @param int $company_id
     * @return \Cocorico\EdnBundle\Wsdl\CarrierCompanyType
     */
    public function setCompany_id($company_id = null)
    {
        // validation for constraint: int
        if (!is_null($company_id) && !(is_int($company_id) || ctype_digit($company_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($company_id, true), gettype($company_id)), __LINE__);
        }
        $this->company_id = $company_id;
        return $this;
    }
    /**
     * Get company_key value
     * @return string
     */
    public function getCompany_key()
    {
        return $this->company_key;
    }
    /**
     * Set company_key value
     * @param string $company_key
     * @return \Cocorico\EdnBundle\Wsdl\CarrierCompanyType
     */
    public function setCompany_key($company_key = null)
    {
        // validation for constraint: string
        if (!is_null($company_key) && !is_string($company_key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_key, true), gettype($company_key)), __LINE__);
        }
        $this->company_key = $company_key;
        return $this;
    }
    /**
     * Get company_name value
     * @return string
     */
    public function getCompany_name()
    {
        return $this->company_name;
    }
    /**
     * Set company_name value
     * @param string $company_name
     * @return \Cocorico\EdnBundle\Wsdl\CarrierCompanyType
     */
    public function setCompany_name($company_name = null)
    {
        // validation for constraint: string
        if (!is_null($company_name) && !is_string($company_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_name, true), gettype($company_name)), __LINE__);
        }
        $this->company_name = $company_name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\CarrierCompanyType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
