<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for carrierOptionsType StructType
 * @subpackage Structs
 */
class CarrierOptionsType extends AbstractStructBase
{
    /**
     * The saturday
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $saturday;
    /**
     * The return
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $return;
    /**
     * Constructor method for carrierOptionsType
     * @uses CarrierOptionsType::setSaturday()
     * @uses CarrierOptionsType::setReturn()
     * @param bool $saturday
     * @param bool $return
     */
    public function __construct($saturday = null, $return = null)
    {
        $this
            ->setSaturday($saturday)
            ->setReturn($return);
    }
    /**
     * Get saturday value
     * @return bool|null
     */
    public function getSaturday()
    {
        return $this->saturday;
    }
    /**
     * Set saturday value
     * @param bool $saturday
     * @return \Cocorico\EdnBundle\Wsdl\CarrierOptionsType
     */
    public function setSaturday($saturday = null)
    {
        // validation for constraint: boolean
        if (!is_null($saturday) && !is_bool($saturday)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($saturday, true), gettype($saturday)), __LINE__);
        }
        $this->saturday = $saturday;
        return $this;
    }
    /**
     * Get return value
     * @return bool|null
     */
    public function getReturn()
    {
        return $this->return;
    }
    /**
     * Set return value
     * @param bool $return
     * @return \Cocorico\EdnBundle\Wsdl\CarrierOptionsType
     */
    public function setReturn($return = null)
    {
        // validation for constraint: boolean
        if (!is_null($return) && !is_bool($return)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($return, true), gettype($return)), __LINE__);
        }
        $this->return = $return;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\CarrierOptionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
