<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for carrierType StructType
 * @subpackage Structs
 */
class CarrierType extends AbstractStructBase
{
    /**
     * The service
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $service;
    /**
     * The service_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $service_name;
    /**
     * The carrier
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $carrier;
    /**
     * The carrier_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $carrier_name;
    /**
     * The carrier_description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $carrier_description;
    /**
     * The carrier_logo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $carrier_logo;
    /**
     * Constructor method for carrierType
     * @uses CarrierType::setService()
     * @uses CarrierType::setService_name()
     * @uses CarrierType::setCarrier()
     * @uses CarrierType::setCarrier_name()
     * @uses CarrierType::setCarrier_description()
     * @uses CarrierType::setCarrier_logo()
     * @param string $service
     * @param string $service_name
     * @param string $carrier
     * @param string $carrier_name
     * @param string $carrier_description
     * @param string $carrier_logo
     */
    public function __construct($service = null, $service_name = null, $carrier = null, $carrier_name = null, $carrier_description = null, $carrier_logo = null)
    {
        $this
            ->setService($service)
            ->setService_name($service_name)
            ->setCarrier($carrier)
            ->setCarrier_name($carrier_name)
            ->setCarrier_description($carrier_description)
            ->setCarrier_logo($carrier_logo);
    }
    /**
     * Get service value
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * Set service value
     * @uses \Cocorico\EdnBundle\Wsdl\EnumServiceType::valueIsValid()
     * @uses \Cocorico\EdnBundle\Wsdl\EnumServiceType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $service
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setService($service = null)
    {
        // validation for constraint: enumeration
        if (!\Cocorico\EdnBundle\Wsdl\EnumServiceType::valueIsValid($service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cocorico\EdnBundle\Wsdl\EnumServiceType', is_array($service) ? implode(', ', $service) : var_export($service, true), implode(', ', \Cocorico\EdnBundle\Wsdl\EnumServiceType::getValidValues())), __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Get service_name value
     * @return string
     */
    public function getService_name()
    {
        return $this->service_name;
    }
    /**
     * Set service_name value
     * @param string $service_name
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setService_name($service_name = null)
    {
        // validation for constraint: string
        if (!is_null($service_name) && !is_string($service_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($service_name, true), gettype($service_name)), __LINE__);
        }
        $this->service_name = $service_name;
        return $this;
    }
    /**
     * Get carrier value
     * @return string
     */
    public function getCarrier()
    {
        return $this->carrier;
    }
    /**
     * Set carrier value
     * @uses \Cocorico\EdnBundle\Wsdl\EnumCarrierType::valueIsValid()
     * @uses \Cocorico\EdnBundle\Wsdl\EnumCarrierType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $carrier
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setCarrier($carrier = null)
    {
        // validation for constraint: enumeration
        if (!\Cocorico\EdnBundle\Wsdl\EnumCarrierType::valueIsValid($carrier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cocorico\EdnBundle\Wsdl\EnumCarrierType', is_array($carrier) ? implode(', ', $carrier) : var_export($carrier, true), implode(', ', \Cocorico\EdnBundle\Wsdl\EnumCarrierType::getValidValues())), __LINE__);
        }
        $this->carrier = $carrier;
        return $this;
    }
    /**
     * Get carrier_name value
     * @return string
     */
    public function getCarrier_name()
    {
        return $this->carrier_name;
    }
    /**
     * Set carrier_name value
     * @param string $carrier_name
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setCarrier_name($carrier_name = null)
    {
        // validation for constraint: string
        if (!is_null($carrier_name) && !is_string($carrier_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrier_name, true), gettype($carrier_name)), __LINE__);
        }
        $this->carrier_name = $carrier_name;
        return $this;
    }
    /**
     * Get carrier_description value
     * @return string
     */
    public function getCarrier_description()
    {
        return $this->carrier_description;
    }
    /**
     * Set carrier_description value
     * @param string $carrier_description
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setCarrier_description($carrier_description = null)
    {
        // validation for constraint: string
        if (!is_null($carrier_description) && !is_string($carrier_description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrier_description, true), gettype($carrier_description)), __LINE__);
        }
        $this->carrier_description = $carrier_description;
        return $this;
    }
    /**
     * Get carrier_logo value
     * @return string
     */
    public function getCarrier_logo()
    {
        return $this->carrier_logo;
    }
    /**
     * Set carrier_logo value
     * @param string $carrier_logo
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public function setCarrier_logo($carrier_logo = null)
    {
        // validation for constraint: string
        if (!is_null($carrier_logo) && !is_string($carrier_logo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrier_logo, true), gettype($carrier_logo)), __LINE__);
        }
        $this->carrier_logo = $carrier_logo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\CarrierType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
