<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createPickupResponse StructType
 * @subpackage Structs
 */
class CreatePickupResponse extends AbstractStructBase
{
    /**
     * The id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $id;
    /**
     * The reservation_number
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $reservation_number;
    /**
     * The pdf
     * Meta information extracted from the WSDL
     * - documentation: Url of the PDF label
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $pdf;
    /**
     * The trackingnumber
     * Meta information extracted from the WSDL
     * - documentation: Tracking number of the created shipment
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $trackingnumber;
    /**
     * Constructor method for createPickupResponse
     * @uses CreatePickupResponse::setId()
     * @uses CreatePickupResponse::setReservation_number()
     * @uses CreatePickupResponse::setPdf()
     * @uses CreatePickupResponse::setTrackingnumber()
     * @param int $id
     * @param string $reservation_number
     * @param string $pdf
     * @param string $trackingnumber
     */
    public function __construct($id = null, $reservation_number = null, $pdf = null, $trackingnumber = null)
    {
        $this
            ->setId($id)
            ->setReservation_number($reservation_number)
            ->setPdf($pdf)
            ->setTrackingnumber($trackingnumber);
    }
    /**
     * Get id value
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \Cocorico\EdnBundle\Wsdl\CreatePickupResponse
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get reservation_number value
     * @return string
     */
    public function getReservation_number()
    {
        return $this->reservation_number;
    }
    /**
     * Set reservation_number value
     * @param string $reservation_number
     * @return \Cocorico\EdnBundle\Wsdl\CreatePickupResponse
     */
    public function setReservation_number($reservation_number = null)
    {
        // validation for constraint: string
        if (!is_null($reservation_number) && !is_string($reservation_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reservation_number, true), gettype($reservation_number)), __LINE__);
        }
        $this->reservation_number = $reservation_number;
        return $this;
    }
    /**
     * Get pdf value
     * @return string|null
     */
    public function getPdf()
    {
        return $this->pdf;
    }
    /**
     * Set pdf value
     * @param string $pdf
     * @return \Cocorico\EdnBundle\Wsdl\CreatePickupResponse
     */
    public function setPdf($pdf = null)
    {
        // validation for constraint: string
        if (!is_null($pdf) && !is_string($pdf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pdf, true), gettype($pdf)), __LINE__);
        }
        $this->pdf = $pdf;
        return $this;
    }
    /**
     * Get trackingnumber value
     * @return string|null
     */
    public function getTrackingnumber()
    {
        return $this->trackingnumber;
    }
    /**
     * Set trackingnumber value
     * @param string $trackingnumber
     * @return \Cocorico\EdnBundle\Wsdl\CreatePickupResponse
     */
    public function setTrackingnumber($trackingnumber = null)
    {
        // validation for constraint: string
        if (!is_null($trackingnumber) && !is_string($trackingnumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trackingnumber, true), gettype($trackingnumber)), __LINE__);
        }
        $this->trackingnumber = $trackingnumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\CreatePickupResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
