<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for findRelaysResponse StructType
 * @subpackage Structs
 */
class FindRelaysResponse extends AbstractStructBase
{
    /**
     * The relays
     * Meta information extracted from the WSDL
     * - arrayType: tns:relayType[]
     * - base: SOAP-ENC:Array
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: SOAP-ENC:arrayType
     * @var \Cocorico\EdnBundle\Wsdl\RelayType[]
     */
    public $relays;
    /**
     * Constructor method for findRelaysResponse
     * @uses FindRelaysResponse::setRelays()
     * @param \Cocorico\EdnBundle\Wsdl\RelayType[] $relays
     */
    public function __construct(array $relays = array())
    {
        $this
            ->setRelays($relays);
    }
    /**
     * Get relays value
     * @return \Cocorico\EdnBundle\Wsdl\RelayType[]|null
     */
    public function getRelays()
    {
        return $this->relays;
    }
    /**
     * This method is responsible for validating the values passed to the setRelays method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelays method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelaysForArrayConstraintsFromSetRelays(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $findRelaysResponseRelaysItem) {
            // validation for constraint: itemType
            if (!$findRelaysResponseRelaysItem instanceof \Cocorico\EdnBundle\Wsdl\RelayType) {
                $invalidValues[] = is_object($findRelaysResponseRelaysItem) ? get_class($findRelaysResponseRelaysItem) : sprintf('%s(%s)', gettype($findRelaysResponseRelaysItem), var_export($findRelaysResponseRelaysItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The relays property can only contain items of type \Cocorico\EdnBundle\Wsdl\RelayType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set relays value
     * @throws \InvalidArgumentException
     * @param \Cocorico\EdnBundle\Wsdl\RelayType[] $relays
     * @return \Cocorico\EdnBundle\Wsdl\FindRelaysResponse
     */
    public function setRelays(array $relays = array())
    {
        // validation for constraint: array
        if ('' !== ($relaysArrayErrorMessage = self::validateRelaysForArrayConstraintsFromSetRelays($relays))) {
            throw new \InvalidArgumentException($relaysArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(1)
        if (is_array($relays) && count($relays) > 1) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 1', count($relays)), __LINE__);
        }
        $this->relays = $relays;
        return $this;
    }
    /**
     * Add item to relays value
     * @throws \InvalidArgumentException
     * @param \Cocorico\EdnBundle\Wsdl\RelayType $item
     * @return \Cocorico\EdnBundle\Wsdl\FindRelaysResponse
     */
    public function addToRelays(\Cocorico\EdnBundle\Wsdl\RelayType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cocorico\EdnBundle\Wsdl\RelayType) {
            throw new \InvalidArgumentException(sprintf('The relays property can only contain items of type \Cocorico\EdnBundle\Wsdl\RelayType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(1)
        if (is_array($this->relays) && count($this->relays) >= 1) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 1', count($this->relays)), __LINE__);
        }
        $this->relays[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\FindRelaysResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
