<?php

namespace Cocorico\EdnBundle\Wsdl;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getCarrierCompaniesResponse StructType
 * @subpackage Structs
 */
class GetCarrierCompaniesResponse extends AbstractStructBase
{
    /**
     * The carrier_companies
     * Meta information extracted from the WSDL
     * - arrayType: tns:carrierCompanyType[]
     * - base: SOAP-ENC:Array
     * - maxOccurs: 1
     * - minOccurs: 1
     * - ref: SOAP-ENC:arrayType
     * @var \Cocorico\EdnBundle\Wsdl\CarrierCompanyType[]
     */
    public $carrier_companies;
    /**
     * Constructor method for getCarrierCompaniesResponse
     * @uses GetCarrierCompaniesResponse::setCarrier_companies()
     * @param \Cocorico\EdnBundle\Wsdl\CarrierCompanyType[] $carrier_companies
     */
    public function __construct(array $carrier_companies = array())
    {
        $this
            ->setCarrier_companies($carrier_companies);
    }
    /**
     * Get carrier_companies value
     * @return \Cocorico\EdnBundle\Wsdl\CarrierCompanyType[]
     */
    public function getCarrier_companies()
    {
        return $this->carrier_companies;
    }
    /**
     * This method is responsible for validating the values passed to the setCarrier_companies method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCarrier_companies method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCarrier_companiesForArrayConstraintsFromSetCarrier_companies(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getCarrierCompaniesResponseCarrier_companiesItem) {
            // validation for constraint: itemType
            if (!$getCarrierCompaniesResponseCarrier_companiesItem instanceof \Cocorico\EdnBundle\Wsdl\CarrierCompanyType) {
                $invalidValues[] = is_object($getCarrierCompaniesResponseCarrier_companiesItem) ? get_class($getCarrierCompaniesResponseCarrier_companiesItem) : sprintf('%s(%s)', gettype($getCarrierCompaniesResponseCarrier_companiesItem), var_export($getCarrierCompaniesResponseCarrier_companiesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The carrier_companies property can only contain items of type \Cocorico\EdnBundle\Wsdl\CarrierCompanyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set carrier_companies value
     * @throws \InvalidArgumentException
     * @param \Cocorico\EdnBundle\Wsdl\CarrierCompanyType[] $carrier_companies
     * @return \Cocorico\EdnBundle\Wsdl\GetCarrierCompaniesResponse
     */
    public function setCarrier_companies(array $carrier_companies = array())
    {
        // validation for constraint: array
        if ('' !== ($carrier_companiesArrayErrorMessage = self::validateCarrier_companiesForArrayConstraintsFromSetCarrier_companies($carrier_companies))) {
            throw new \InvalidArgumentException($carrier_companiesArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(1)
        if (is_array($carrier_companies) && count($carrier_companies) > 1) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 1', count($carrier_companies)), __LINE__);
        }
        $this->carrier_companies = $carrier_companies;
        return $this;
    }
    /**
     * Add item to carrier_companies value
     * @throws \InvalidArgumentException
     * @param \Cocorico\EdnBundle\Wsdl\CarrierCompanyType $item
     * @return \Cocorico\EdnBundle\Wsdl\GetCarrierCompaniesResponse
     */
    public function addToCarrier_companies(\Cocorico\EdnBundle\Wsdl\CarrierCompanyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cocorico\EdnBundle\Wsdl\CarrierCompanyType) {
            throw new \InvalidArgumentException(sprintf('The carrier_companies property can only contain items of type \Cocorico\EdnBundle\Wsdl\CarrierCompanyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(1)
        if (is_array($this->carrier_companies) && count($this->carrier_companies) >= 1) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 1', count($this->carrier_companies)), __LINE__);
        }
        $this->carrier_companies[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Cocorico\EdnBundle\Wsdl\GetCarrierCompaniesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
